#if !defined(RLSEM_HPP)

#define RLSEM_HPP





#include <cstddef>

#include "mixmodel.hpp"

#include "data.hpp"





enum RLSEMSwapType { RLSEMSwap_Random, RLSEMSwap_PostPartitioning,

    RLSEMSwap_EraseCreate, RLSEMSwap_PartitionSwapped};



// Expects that the mixture model has been initialized with valid values.

// Returns log likelihood. MinimumVariances is either a row or column

// matrix that contains the minimum allowed values.

double RLSExpectationMaximization(MixtureModel& MM, const Data& D,

    const Matrix& MinimumVariances, int RLSIterations, int EMIterations,

    RLSEMSwapType SwapType, bool Verbose = false);

double RLSExpectationMaximization(MixtureModel& MM, const Data& D,

    const Matrix& MinimumVariances, int RLSIterations, double Threshold,

    RLSEMSwapType SwapType, bool Verbose = false);



#endif



